Block = function(x,y,parentCharacter){
	this.x = x;
	this.y = y;
	this.parentCharacter = parentCharacter;
	this.visited = false;

	map.getTile(
		this.getRealX(),
		this.getRealY()
	).block = this;

	this.color = new Color(
		this.parentCharacter.h+this.y+this.x,
		this.parentCharacter.s,
		this.parentCharacter.l
	);

	item = null;
}

Block.prototype.getParentId = function(){
	return this.parentCharacter.x +','+this.parentCharacter.y;
}

Block.prototype.getRealX = function(){
	return this.parentCharacter.x + this.x;
}

Block.prototype.getRealY = function(){
	return this.parentCharacter.y + this.y;
}

Block.prototype.isCenter = function(){
	if(this.x==0 && this.y==0){
		return true;
	}else{
		return false;
	}
}

Block.prototype.getTile = function(){
	return map.getTile(this.getRealX(),this.getRealY());
}

Block.prototype.equals = function(block){
	if(this.x==block.x && this.y==block.y){
		return true;
	}else{
		return false;
	}
}

Block.prototype.deleteYoself = function(){
	this.getTile().decayEffect = {
		frameStart:frameCounter,
		color: this.color.string
	}
	if(this.item != null){
		this.item.drop();
	}

	this.getTile().block = null;

	var parentBlocks = this.parentCharacter.blocks;
	for(var i=0;i<parentBlocks.length;i++){
		if(parentBlocks[i].equals(this)){
			parentBlocks.splice(i,1);
			return;
		}
	}
}