frameCounter = 0;

$(function(){
	var canvas = $("#canvas")[0];

	browserWidth = window.innerWidth;
	browserHeight = window.innerHeight;

	var scaledSize = Math.min(browserWidth,browserHeight-100, 630);

	canvas.width = 630;
	canvas.height = 630;

	$("#canvas").css({
		width: scaledSize + "px",
		height: scaledSize + "px"
	});

	$(".button-control").css({
		width: Math.floor((scaledSize-36)/3) + "px",
		height: Math.floor((browserHeight-scaledSize-14-50)/2) + "px"
	});


	var ctx = canvas.getContext("2d");
	ctx.imageSmoothingEnabled = false;
	ctx.mozImageSmoothingEnabled = false;

	game.canvasWidth = 630;
	game.canvasHeight= 630;

	game.crownCanvas = document.createElement('canvas');
	game.crownCtx = game.crownCanvas.getContext('2d');
	game.crownCanvas.width = map.tileSize * 3;
    game.crownCanvas.height = map.tileSize * 3;

	game.gateCanvas = document.createElement('canvas');
	game.gateCtx = game.gateCanvas.getContext('2d');
	game.gateCanvas.width = map.tileSize * 3;
    game.gateCanvas.height = map.tileSize * 3;

  	//game.start();

  	game.title();
  	

  	//game.howto();

  	//game.end();

	var currentTime = Date.now();


	$("#control-zoom-out").click(function(e){
		console.log("wtf1")
		if(game.state=="running"){
			game.zoomIn();
		}
	});
	$("#control-zoom-in").click(function(e){
		console.log("wtf2")
		if(game.state=="running"){
			game.zoomOut();
		}
	});
	$("#control-up").click(function(e){
		if(game.state=="running"){
			game.pushMove({x:0,y:-1});
		}
	});
	$("#control-down").click(function(e){
		if(game.state=="running"){
			game.pushMove({x:0,y:1});
		}
	});
	$("#control-left").click(function(e){
		if(game.state=="running"){
			game.pushMove({x:-1,y:0});
		}
	});
	$("#control-right").click(function(e){
		if(game.state=="running"){
			game.pushMove({x:1,y:0});
		}
	});

	$('*').on('mousewheel', function(event) {
		if(!game.wheelZooming && game.state=="running"){
			game.wheelZooming = true;
			if(event.deltaY<0){
				game.zoomOut();
			}else if(event.deltaY>0){
				game.zoomIn();
			}
			setTimeout(function(){
				game.wheelZooming = false;
			},100);
		}
	});


	$(document).on("contextmenu", "canvas", function(e){
	   return false;
	});

	$('.menu-item').hover(function(){
		$(".menu-item-active").removeClass("menu-item-active");
		$(this).addClass("menu-item-active");
	});

	$("#menu-start").click(function(){
		game.start();
	});

	$("#menu-howto").click(function(){
		game.howto();
	});

	$("#menu-credits").click(function(){
		game.credits();
	});

	$("#menu-leaderboards").click(function(){
		game.leaderboards();
	});

	$("#username-change").click(function(){
		game.changeUsername();
	});

	$('html').mousedown(function(e) {
		if(game.state=="howto"){
	    	game.howtoIncrement();
	    	e.preventDefault();
			e.stopPropagation();
	    }else if(game.state=="credits"){
	    	game.title();
	    	e.preventDefault();
			e.stopPropagation();
	    }else if(game.state=="end-text"){
	    	game.title();
	    	e.preventDefault();
			e.stopPropagation();
	    }
    });

	$("html").keydown(function(e){
		k=e.which;

		if(game.state=="running"){
			if(k==81){
				game.zoomIn();
	    	}

	    	if(k==69){
	    		game.zoomOut();
			}

			if(k==87 || k==38 || k==75){
				game.pushMove({x:0,y:-1});
				e.preventDefault();
				e.stopPropagation();
			}
			if(k==83 || k==40 || k==74){
				game.pushMove({x:0,y:1});
				e.preventDefault();
				e.stopPropagation();
			}
			if(k==65 || k==37 || k==72){
				game.pushMove({x:-1,y:0});
				e.preventDefault();
				e.stopPropagation();
			}
			if(k==68 || k==39 || k==76){
				game.pushMove({x:1,y:0});
				e.preventDefault();
				e.stopPropagation();
			}
		}else if(game.state=="title"){
			if(k==87 || k==38 || k==75){
				var numItems = $(".menu-item").length;
				var index = $(".menu-item-active").index();
				var newIndex=(index+numItems-1) % numItems+1;
				$(".menu-item-active").removeClass("menu-item-active")
				$(".menu-item:nth-child("+newIndex+")").addClass("menu-item-active");

				e.preventDefault();
				e.stopPropagation();
			}
			if(k==83 || k==40 || k==74){
				var numItems = $(".menu-item").length;
				var index = $(".menu-item-active").index();
				var newIndex=(index+1) % numItems+1;
				$(".menu-item-active").removeClass("menu-item-active")
				$(".menu-item:nth-child("+newIndex+")").addClass("menu-item-active");

				e.preventDefault();
				e.stopPropagation();
			}

			if(k==32 || k == 13){
				if($("#menu-start").hasClass("menu-item-active")){
					game.start();
				}

				if($("#menu-howto").hasClass("menu-item-active")){
					game.howto();
				}

				if($("#menu-credits").hasClass("menu-item-active")){
					game.credits();
				}

				if($("#menu-leaderboards").hasClass("menu-item-active")){
					game.leaderboards();
				}
			}
		}else if(game.state=="howto"){
	    	game.howtoIncrement();
	    }else if(game.state=="credits"){
	    	game.title();
	    }else if(game.state=="end-text"){
	    	game.title();
	    }
	});


	var framerate = 0;

	var dunes = [];
  	for(var i=0;i<10;i++){
  		dunes.push({
  			x:Math.random()*1500-500,
  			y:Math.random()*1500-500,
  			r:Math.random()*500+500
  		})
  	}


	var gameLoop = function(timestamp){
		frameCounter++;
		game.speedCounter++;
		if(game.state=="running" || game.state=="dead" || game.state=="nextLevel"){

			ctx.clearRect(0,0,game.canvasWidth,game.canvasHeight);
	  		var dt = timestamp - currentTime;		
	  		currentTime = timestamp;

	      	ctx.lineWidth = 25;

	      	//ZOOM ZOOM ZOOM
	      	game.zoom = game.zoom + (game.targetZoom-game.zoom)*.75;

	      	if(Math.abs((game.targetZoom-game.zoom)/game.targetZoom)<.05){
	      		game.zoom = game.targetZoom;
	      	}


	      	game.computeLos();


			

	      	/*
	      	ctx.globalCompositeOperation = 'darker';
	      	for(var i=0;i<dunes.length;i++){
	      		var duneX = dunes[i].x;
	      		var duneY = dunes[i].y;
	      		var duneR = dunes[i].r;
	      		var grd=ctx.createLinearGradient(0,duneY+duneR*.82,0,duneY+duneR);
				grd.addColorStop(0,'hsla(21,37%,75%,1)');
				grd.addColorStop(1,'hsla(21,41%,68%,1)');
				ctx.fillStyle=grd;
				ctx.beginPath();
		      	ctx.arc(duneX, duneY, duneR, Math.PI*.3, Math.PI*.7, false);
		      	ctx.fill();
	      	}*/
	  		
	      	map.draw(ctx);


	      	game.drawPatterns(ctx);
	  		game.handleMonsters(ctx);


	      	pc.update(dt);
	      	if(game.state!="dead"){
	  			pc.draw(ctx);
	  		}


	  		if(frameCounter % 60 == 0 ){
	  			framerate=Math.floor(1000/dt);
	  		}
	  		ctx.font = "20px serif";
	  		ctx.fillStyle = "black";
	  		//ctx.fillText(framerate, game.canvasWidth-100, game.canvasHeight-50);

	  		//ctx.fillText("Score: "+game.score, 100, game.canvasHeight-50);

	  		if(game.crownTile != null){
	  			game.crownTile.drawCrown(ctx);
	  		}
	  		if(game.gateTile != null){
	  			game.gateTile.drawGate(ctx);
	  		}
	  	}


  		if(game.state=="end"){
	  		game.targetZoom = 1;
			ctx.fillStyle = "hsla(0,0%,100%,"+Math.min(1,(frameCounter-game.frameEnding)/1500)+")";
			ctx.fillRect(0,0,game.canvasWidth,game.canvasHeight)
			if(Math.random()<game.cancerChance){
				game.cancerChance=1-(1-game.cancerChance)*.99
				pc.cancer();
			}
			pc.calculateCanvas(true, 1-Math.pow(game.cancerChance,3));
			pc.draw(ctx);

			if(game.cancerChance>.995){
				game.state="end-text";
				game.overlay("ending-text",2000,function(){
					$("#outer").css({opacity:0});
				});
			}
		}

  		window.requestAnimationFrame(gameLoop);
	}







	window.requestAnimationFrame(gameLoop);
});